//
// Titel      ME Cover-control
// by         Markus Emmerich
// Copyright (C) 2016 Markus Emmerich
// http://squirrel-observatory.de


// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//  ---------------------------------

// V 1.0 - 16.05.2016 - Veröffentlichung der ersten Version
// V 1.1 - 21.05.2016 - Übergabewete wurden von HEX auf DEC geändert

// Beschreibung
//
// Die einwandfreihe Funktion ist nur mit der gleichen Versionsnummer von App und Sketch sicher gestellt.
// Die App steuert den Reomte-Cocer auf Arduino-Basis. Als standart COM-Port wird Com2 genutz. Soll ein anderer Port
// genutzt werden muss der entsprechende Eintrag in Zeile 47 und 53 geändert werden.
    
    import processing.serial.*;
    int zustand =0;
    
    Serial myPort;
    
    float x = 20;
    float y = 15;
    float w = 85;
    float h = 24;
    float tx = x+10;
    PImage img;
    
    void setup(){
//     println(Serial.list());
//     myPort = new Serial(this, Serial.list()[1], 9600); 
//     String portName = Serial.list()[0];
     myPort = new Serial(this,"COM2", 9600);                  // Com-Port ggfl.anpassen
     
     size(250,130);
     background(0);
     fill(60,60,60);
     textSize(16);
     text("COM 2",tx, y+20);
     fill(120,120,120);
     textSize(9);
     text("ME Cover-control v1.1", x, 120);                   // Com-Port ggfl.anpassen


}

    void draw(){
    
     while (myPort.available() > 0) {
     int inByte = myPort.read();
     println(inByte);
     zustand = inByte;   
    }
    
      
     if(zustand ==0x30){      
     fill(0); 
     stroke (60,60,60);
     ellipse(180, 65, 100, 100);
     cover1();
     }
     
     if(zustand ==0x31){      
     fill(0); 
     stroke (60,60,60);
     ellipse(180, 65, 100, 100);
     cover2();
     }
    }
    
   void mouseReleased() {
     
     if(zustand ==0x30){
     if(mouseX>x && mouseX <x+w && mouseY>y+40 && mouseY <y+h+40){
     fill(0);
     stroke (60,60,60);
     rect(x,y+40,w,h);
     fill(255,200,0);
     myPort.write(1);
     delay(100);
      }    
     } 
     
     if(zustand ==0x31){
     if(mouseX>x && mouseX <x+w && mouseY>y+40 && mouseY <y+h+40){
     fill(0);
     stroke (60,60,60);
     rect(x,y+40,w,h);
     fill(255,200,0);
     myPort.write(0);
     delay(100);
      }
     }
    }
    

  void cover1(){   
          
     fill(0);
     stroke (60,60,60);
     rect(x,y+40,w,h);
     fill(120,120,120);
     textSize(20);
     text("open", tx, y+19+40);     
    }

  void cover2(){   
     
     fill(0);
     stroke (60,60,60);
     rect(x,y+40,w,h);
     fill(120,120,120);
     textSize(20);
     text("close", tx, y+19+40);
     img = loadImage("background.gif");
     image(img, 131, 16);
    }
 